view scripts/backup-container.sh @ 321:2cb1093f9aef

making changes to remote backup scripts to account for no IRN
author aldrich@ssdt-ohio.org
date Thu, 31 Oct 2019 14:40:02 +0100
parents 58c49a386a11
children
line wrap: on
line source
#!/bin/bash
# Executes a database backup for the specifed database container.  
# The current directory is expected to contaion a project configured
# as with SSDT conventions for an application database.
#
# When successful, the output file will be in ./backup with the
# container name and timestamp in the file.  The format of the output
# is a compressed pg_dump (sql) format.
#
container=${1?Must provide container name to backup}

projectDir=${2:-$PWD}

cd $projectDir

source "${SSDT_SCRIPTS:-$(dirname "${BASH_SOURCE[0]}")}/.functions.sh"

project=$(composeGetProject)

#If the project is empty, we want to stop the process because this is being run from the wrong directory

if [ "$project" == "" ]; then
   echo "no project available"
   exit 1
fi

set -o pipefail
mkdir -p ./backup
##
##This one puts a space before the IRN
IRN=$(docker-compose exec -T $container psql --username=postgres --dbname=$container -t -c 'select irn from organization') 
##Trim function in postgres didn't work - so take out the extra space this way.
IRN=`echo $IRN | sed -e 's/^[[:space:]]*//'`

## if database is empty, it will put IRN 000000
if [ "$IRN" == "" ]; then
   echo "no IRN set,using 000000"
    IRN=000000
fi

backupFile=./backup/${IRN}${project}-${container}.$(date +%Y-%m-%d-%H-%M-%S).backup

echo "Project is $project"
echo "Container is $container"
echo "IRN is $IRN"

echo "backup file ${backupFile}"
echo "preparing to backup ${container} on current project at ${projectDir}:"
echo " "



echo "starting backup of $container for $project"
docker-compose exec -T $container sh -c "gosu postgres pg_dump -Cc --if-exists --dbname=$container ; (exit $?) " > ${backupFile}

if [[ $( grep --count "CREATE TABLE" ${backupFile} ) -lt 200 || $( grep --count "PostgreSQL database dump complete" ${backupFile} ) -eq 0 ]]; then
   echo "ERROR: backup verification FAILED"
   echo "Error: empty database"
   echo "ERROR: $(tail ${backupFile})"
  # We want the process to continue even if the db is blank
  # exit 1
fi

gzip ${backupFile}


echo "completed backup of $container for $project to ${backupFile}"